// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Channels.pas' rev: 3.00

#ifndef ChannelsHPP
#define ChannelsHPP
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Channels
{
//-- type declarations -------------------------------------------------------
#pragma pack(push, 1)
struct TRGBEntry
{
	Byte R;
	Byte G;
	Byte B;
	Byte C;
} ;
#pragma pack(pop)

typedef TRGBEntry TRGBPalette[256];

typedef TRGBPalette *PRGBPalette;

typedef Windows::TRect TRects[1001];

typedef TRects *PRects;

enum TAligns { aFrame, aFrameLeft, aFrameTop, aFrameRight, aFrameBottom, aCenter, aLeft, aUp, aRight, 
	aDown, aLeftUp, aLeftDown, aRightUp, aRightDown, aTile, aScale, aStretch };

typedef TAligns TChannelAlign;

typedef TAligns TImageAlign;

typedef TAligns TTextAlign;

typedef TAligns TGlyphAlign;

class DELPHICLASS TProChannel;
class PASCALIMPLEMENTATION TProChannel : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FActive;
	tagPOINT FSize;
	void *FImage;
	Byte FPixelSize;
	void __fastcall SetSize(const tagPOINT &ASize);
	void __fastcall SetActive(bool AActive);
	virtual void __fastcall Activate(void) = 0;
	virtual void __fastcall Deactivate(void) = 0;
	Windows::TRect __fastcall GetExtents(void);
	
public:
	int __fastcall DataSize(void);
	void * __fastcall Seek(int APosX, int APosY);
	__fastcall TProChannel(Byte APixelSize);
	__fastcall virtual ~TProChannel(void);
	__property Windows::TRect Extents = {read=GetExtents};
	__property tagPOINT Size = {read=FSize, write=SetSize};
	__property bool Active = {read=FActive, write=SetActive, nodefault};
	__property Byte PixelSize = {read=FPixelSize, nodefault};
	__property void * Image = {read=FImage};
};

enum TChannelMode { cmColorChannel, cmAlphaChannel };

class DELPHICLASS TChannel;
class PASCALIMPLEMENTATION TChannel : public Channels::TProChannel 
{
	typedef Channels::TProChannel inherited;
	
private:
	TRGBPalette *FPalette;
	TChannelMode FMode;
	Classes::TNotifyEvent FOnChange;
	virtual void __fastcall Activate(void);
	virtual void __fastcall Deactivate(void);
	
public:
	__fastcall TChannel(TChannelMode AMode);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall LoadFromFileStream(Classes::TStream* AStream);
	void __fastcall LoadFromStream(Classes::TStream* AStream);
	void __fastcall SaveToStream(Classes::TStream* AStream);
	void __fastcall SaveToFile(const System::AnsiString AFileName);
	void __fastcall LoadFromResourceID(int ResID);
	void __fastcall LoadFromResourceName(const System::AnsiString ResName);
	void __fastcall LoadFromFile(const System::AnsiString AFileName);
	__property PRGBPalette Palette = {read=FPalette};
	__property TChannelMode Mode = {read=FMode, nodefault};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
public:
	/* TProChannel.Destroy */ __fastcall virtual ~TChannel(void) { }
	
};

class DELPHICLASS TRGBCanvas;
class PASCALIMPLEMENTATION TRGBCanvas : public Graphics::TCanvas 
{
	typedef Graphics::TCanvas inherited;
	
private:
	HBITMAP FBitmap;
	
public:
	__fastcall TRGBCanvas(HBITMAP AChannel);
	__fastcall virtual ~TRGBCanvas(void);
};

class DELPHICLASS TRGBChannel;
class PASCALIMPLEMENTATION TRGBChannel : public Channels::TProChannel 
{
	typedef Channels::TProChannel inherited;
	
private:
	HBITMAP FHandle;
	TRGBCanvas* FCanvas;
	virtual void __fastcall Activate(void);
	virtual void __fastcall Deactivate(void);
	void __fastcall AlphaChannelFrame(const Windows::TRect &AClip, const Windows::TRect &RGBArea, TChannel* 
		AAlphaChannel);
	
public:
	__fastcall virtual TRGBChannel(void);
	__property HBITMAP Handle = {read=FHandle, nodefault};
	__property TRGBCanvas* Canvas = {read=FCanvas};
	void __fastcall Luminosity(Shortint ALuminosity);
	void __fastcall LuminosityRect(const Windows::TRect &AClip, Shortint ALuminosity);
	void __fastcall WhiteAlphaChannel(const Windows::TRect &AClip, const tagPOINT &APos, TChannel* AAlphaChannel
		);
	void __fastcall ColorAlphaChannel(const Windows::TRect &AClip, const tagPOINT &APos, Graphics::TColor 
		AColor, TChannel* AAlphaChannel, Byte AAlpha);
	void __fastcall ColorChannel(const Windows::TRect &AClip, const tagPOINT &APos, TChannel* AColorChannel
		, Byte AAlpha);
	void __fastcall AlphaColorChannel(const Windows::TRect &AClip, const tagPOINT &APos, TChannel* AColorChannel
		, TChannel* AAlphaChannel, Byte AAlpha);
	void __fastcall AlphaChannelAlign(const Windows::TRect &AClip, const Windows::TRect &ARect, Graphics::TColor 
		AColor, TChannel* AAlphaChannel, TChannelAlign AAlign);
public:
	/* TProChannel.Destroy */ __fastcall virtual ~TRGBChannel(void) { }
	
};

class DELPHICLASS TClipChannel;
class PASCALIMPLEMENTATION TClipChannel : public Channels::TRGBChannel 
{
	typedef Channels::TRGBChannel inherited;
	
private:
	_RGNDATA *FRegions;
	int FRegMem;
	TRects *FRects;
	HRGN FRegion;
	bool FDrawMode;
	
public:
	bool __fastcall Resize(const tagPOINT &ANewSize);
	__fastcall virtual ~TClipChannel(void);
	void __fastcall Invalidate(const Windows::TRect &ARect);
	void __fastcall InvalidateAll(void);
	bool __fastcall DrawBegin(void);
	void __fastcall DrawEnd(void);
	HIDESBASE void __fastcall Luminosity(Shortint ALuminosity);
	HIDESBASE void __fastcall WhiteAlphaChannel(const tagPOINT &APos, TChannel* AAlphaChannel);
	HIDESBASE void __fastcall ColorAlphaChannel(const tagPOINT &APos, Graphics::TColor AColor, TChannel* 
		AAlphaChannel, Byte AAlpha);
	HIDESBASE void __fastcall ColorChannel(const tagPOINT &APos, TChannel* AColorChannel, Byte AAlpha);
		
	HIDESBASE void __fastcall AlphaColorChannel(const tagPOINT &APos, TChannel* AColorChannel, TChannel* 
		AAlphaChannel, Byte AAlpha);
	HIDESBASE void __fastcall AlphaChannelAlign(const Windows::TRect &ARect, Graphics::TColor AColor, TChannel* 
		AAlphaChannel, TChannelAlign AAlign);
public:
	/* TRGBChannel.Create */ __fastcall virtual TClipChannel(void) : Channels::TRGBChannel() { }
	
};

class DELPHICLASS EChannelError;
class PASCALIMPLEMENTATION EChannelError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EChannelError(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EChannelError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EChannelError(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EChannelError(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EChannelError(const System::AnsiString Msg, int AHelpContext)
		 : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EChannelError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EChannelError(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EChannelError(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EChannelError(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE Windows::TRect __fastcall AlignRect(const Windows::TRect &ARect, const tagPOINT &ASize
	, TAligns AAlign);

}	/* namespace Channels */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Channels;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Channels
